Vue.config.productionTip = false // 关闭vue生产环境提示

/**
 * @description: 固定定位模拟黏性定位；（前提：jq库支持；）
 * @params: {Selector} stickySel 触发黏性定位的选择器；
 * @params: {Selector} siblingSel 触发黏性定位的选择器 - 同级容器
 * @params: {Selector} size 触发黏性定位的选择器高；（用于计算何时移出固定定位）
 * */
function changeFilterHead(stickySel, siblingSel, size0, size1, SusFixNavHei) {
    var $stickyFilter = $(stickySel) // 触发黏性定位的选择器
    var windowScroll = $(window).scrollTop() + size0 // 网页被卷曲的距离
    var stickyFilterWidth = $stickyFilter.offset().top // 需要定位的容器到顶部距离
    var nextSize = $(siblingSel).offset().top // 同级容器到顶部距离
    // console.log('定位尺寸', windowScroll, stickyFilterWidth, nextSize)
    if (windowScroll > stickyFilterWidth) {
        $stickyFilter.css({
            'position': 'fixed',
            'top': size0 + 'px', // 固定定位位置
            'width': '100%',
            'left': 0,
            'z-index': '98',
        })
        $(siblingSel).css({
            'padding-top': size1 + SusFixNavHei + 'px', // 原始上内边距 + 固定塌陷造成的高
        })
        stickyFilterWidth -= SusFixNavHei // ！触发定位后，要将自身高度减去用于比较
        return
    }
    if (windowScroll < nextSize) {
        $stickyFilter.removeAttr('style')
        $(siblingSel).css({ // 给因固定定位造成的塌陷，添加内距
            'padding-top': SusFixNavHei + 'px'
        })
    }
}

var vum = new Vue({
    el: '#app',
    data: function () {
        return {
            personType:getUrlParam("personType") || 2,
            loading: false, // 是否正在 loading
            isEmpty: 'none', // 是否为空
            baseUrl: testbaserequiredurl, // 当前服务路径
            currentPage: 1, // 当前选中页码
            allIndClassArr: [], // 行业分类
            chiProvinceArr: [
                {Proname: '北京市', isSel: 0, id: 0},
                {Proname: '天津市', isSel: 0, id: 1},
                {Proname: '上海市', isSel: 0, id: 2},
                {Proname: '重庆市', isSel: 0, id: 3},
                {Proname: '河北省', isSel: 0, id: 4},
                {Proname: '山西省', isSel: 0, id: 5},
                {Proname: '辽宁省', isSel: 0, id: 6},
                {Proname: '吉林省', isSel: 0, id: 7},
                {Proname: '黑龙江省', isSel: 0, id: 8},
                {Proname: '江苏省', isSel: 0, id: 9},
                {Proname: '浙江省', isSel: 0, id: 10},
                {Proname: '安徽省', isSel: 0, id: 11},
                {Proname: '福建省', isSel: 0, id: 12},
                {Proname: '江西省', isSel: 0, id: 13},
                {Proname: '山东省', isSel: 0, id: 14},
                {Proname: '河南省', isSel: 0, id: 15},
                {Proname: '湖北省', isSel: 0, id: 16},
                {Proname: '湖南省', isSel: 0, id: 17},
                {Proname: '广东省', isSel: 0, id: 18},
                {Proname: '海南省', isSel: 0, id: 19},
                {Proname: '四川省', isSel: 0, id: 20},
                {Proname: '贵州省', isSel: 0, id: 21},
                {Proname: '云南省', isSel: 0, id: 22},
                {Proname: '陕西省', isSel: 0, id: 23},
                {Proname: '甘肃省', isSel: 0, id: 24},
                {Proname: '青海省', isSel: 0, id: 25},
                {Proname: '台湾省', isSel: 0, id: 26},
                {Proname: '内蒙古自治区', isSel: 0, id: 27},
                {Proname: '广西壮族自治区', isSel: 0, id: 28},
                {Proname: '西藏自治区', isSel: 0, id: 29},
                {Proname: '宁夏回族自治区', isSel: 0, id: 30},
                // {Proname: '新疆维吾尔族自治区', isSel: 0, id: 31},
                {Proname: '新疆维吾尔自治区', isSel: 0, id: 31},
                // {Proname: '香港特别行政区', isSel: 0, id: 32},
                {Proname: '香港', isSel: 0, id: 32},
                // {Proname: '澳门特别行政区', isSel: 0, id: 33},
                {Proname: '澳门', isSel: 0, id: 33},
            ], // 中国省份
            // 请求参数对象
            keyword: '',
            areaNameList: [], // （请求用）行业分类
            provinceList: [], // （请求）省份
            addDateSort: '', // 入库时间排序 1倒序 2升序
            hotSort: '', // 热度排序 1倒序 2升序
            attentionNum: 0, // 我的关注数
            renderListData: [], // 列表渲染数组
            isGetAttentionList: false, // 是否是获取关注列表
            // 分页相关
            listDataCount: 0, // 数据总量
            page: 1,
            pageSize: 0
        }
    },
    computed: {
        isLoginstatus: function () { // 判断是否登录
            var localStorage = window.localStorage
            if (localStorage.getItem('username') != null && localStorage.getItem('password') != null) {
                return true
            } else {
                return false
            }
        },
        countPage: function () { // 总页数
            return Math.ceil(this.listDataCount / this.pageSize)
        }
    },
    created: function () {
        // console.log('base', baserul)
        var _this = this
        _this.pageSize = $('#curPageSize').val() // 初始化页面数
        if (_this.isLoginstatus) _this.getAttentionNum()
        // this.baseUrl = $('#basefile').val()
        // @ 处理行业分类 model 数据
        // var arr = $('#allIndClass').val()
        //     .replace('[', '')
        //     .replace(']', '')
        //     .split(',')
        // // console.log('获取到的行业分类', arr)
        // arr.forEach(function (item, i) {
        //     _this.allIndClassArr.push({indName: item, isSel: 0, id: i + 1, count: 0})
        // })// 生成集合
        _this.switchClassifyHandle()
        _this.classifyCountHandle()
        // getIndClassCount(
        //     function (res) {
        //         var resObj = res.data
        //         // 这里循环的是对象
        //         _this.allIndClassArr.forEach(function (item) {
        //             for (var a in resObj) {
        //                 if (item.id == resObj[a]['status']) {
        //                     item.count = resObj[a]['cout']
        //                 }
        //             }
        //         })
        //     },
        //     function (res) {
        //         _this.$message({
        //             message: res.msg,
        //             type: 'error',
        //             offset: 90
        //         })
        //     }
        // )
        this.keyword = getUrlParam('keyword') || '' // 获取 url 关键词
        var indclassId = getUrlParam('indclass')*1
        _this.allIndClassArr.forEach(function (item) {
            // console.log('t', item.id, indclassId)
            if (item.id == indclassId) {
                item.isSel = 1
                _this.areaNameList.push(indclassId)
            }
        })
        // 获取列表页面的显示条数
        this.isGetAttentionList ? this.getAttentionList() : this.isGetAttentionList ? this.getAttentionList() : this.getListData()
    },
    mounted: function () {
        var _this = this
        // 修改每页尺寸
        $('.pageSizeSelect').change(function () {
            _this.pageSize = $(this).val()
            $(".pageSizeSelect").val(_this.pageSize) // 设置默认的每页尺寸
            // console.log('修改每页尺寸', $(this).val())
            _this.page = 1
            $.ajax({
                url: _this.baseUrl + '/user/setPageSize.html?pageSize=' + _this.pageSize,
                type: 'get',
                async: false,
                success: function () {

                }
            })
            // _this.getListData()
            _this.isGetAttentionList ? _this.getAttentionList() : _this.getListData()
        })
        // 滚动监听
        $(window).scroll(function () {
            changeFilterHead('.operation__bar--pbslayout', '.fixed__sib', 70, 60, 0)
            // 溢出隐藏
            var t = document.documentElement.scrollTop || document.body.scrollTop || window.pageYOffset;
            if (t > $(".new_footer")[0].offsetTop - 90) {
                $(".operation__bar--pbslayout").hide()
            } else {
                $(".operation__bar--pbslayout").show()
            }
        })
    },
    filters: Object.assign({}, achListDetailFilters),
    methods: Object.assign({},
        {
          switchClassifyHandle:function (){
            var _this = this;
            _this.allIndClassArr = []
            getIndSwitchClassify({personType:_this.personType},function (res){
              console.log(res)
              var arr = res.data || []
              arr.forEach(function (item, i) {
                _this.allIndClassArr.push({indName: item.name, isSel: 0, id: item.id, count: 0})
              })
            })
          },
          classifyCountHandle:function (){
            var _this = this;
            getIndClassCount(
              {personType:_this.personType},
              function (res) {
                var resObj = res.data
                // 这里循环的是对象
                _this.allIndClassArr.forEach(function (item) {
                  for (var a in resObj) {
                    if (item.id == resObj[a]['status']) {
                      item.count = resObj[a]['cout']
                    }
                  }
                })
              },
              function (res) {
                _this.$message({
                  message: res.msg,
                  type: 'error',
                  offset: 90
                })
              }
            )
          },
          personTypeHandle:function (type){
            var _this = this;
            _this.personType = type
            _this.switchClassifyHandle()
            _this.classifyCountHandle()
            _this.keyword = ''
            _this.getSearchResult()
          },
          mouseOver:function(id,index) {
            var _this = this
            $.ajax({
              url: testbaserequiredurl + '/achievement/person/addPersonHot.html',
              data: {recordId:id},
              type: 'POST',
              success: function (res) {
                var res = JSON.parse(res)
                if (res.code == 0) {
                  var data = res.data;
                  _this.renderListData[index].hot = data
                }
              },
              error: function (err) {

              },
              complete: function () {

              }
            })
          },
            // @ 分页
            getFirstPage: function () { // 获取第1页数据
                if (this.page == 1) {
                    return this.$message({
                        message: '当前已在首页！',
                        type: 'warning',
                        offset: 90
                    })
                }
                this.page = 1
                // this.getListData()
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            getNextPage: function () { // 获取下一页
                // console.log('当前页', this.page, this.countPage)
                if (this.page >= this.countPage) return this.$message({
                    message: '当前已在尾页！',
                    type: 'warning',
                    offset: 90
                })
                this.page++
                // console.log('增加后', this.page, this.countPage)
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            getPrevPage: function () { // 获取上一页
                if (this.page == 1) return this.$message({
                    message: '当前已在首页！',
                    type: 'warning',
                    offset: 90
                })
                this.page--
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            getoFirstPage: function () {
                this.page = 1
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            getLastPage: function () {
                if (this.page >= this.countPage) {
                    return this.$message({
                        message: '当前已在尾页！',
                        type: 'warning',
                        offset: 90
                    })
                }
                this.page = this.countPage // 这里是需要计算的
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            resetSearchCriteria: function () { // 重置搜索条件
                var _this = this
                _this.resetAreaNameList(_this) // 重置筛选项-行业分类
                _this.resetProvinceList(_this) // 重置筛选项-行业分类
                this.resetGrayFilterItems() // 重置排序
                _this.page = 1 // 页码
            },
            getSearchResult: function () { // 执行搜索
                this.isGetAttentionList = false // 重置为列表获取
                this.resetSearchCriteria()
                // this.getListData()
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            // clearSearchKw: function () {
            //     this.keyword = ''
            //     // this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            // },
            goToTecTalDetail: function (id) { // 去当前点击项详情
                // var id = id || 100
                window.open(this.baseUrl + '/achievement/person/details.html?recordId=' + id)
            },
            getListData: function () {
                var _this = this
                _this.loading = true // 开始加载 loading
                _this.isEmpty = 'none' // 隐藏置空
                _this.renderListData = [] // 清空数据
                var reqObj = {
                    'page.currentPage': _this.page,
                    pageSize: _this.pageSize,
                    keyword: _this.keyword,
                    areaNameList: _this.areaNameList.join(','),
                    provinceList: _this.provinceList.join(','),
                    addDateSort: _this.addDateSort,
                    hotSort: _this.hotSort,
                    personType:_this.personType
                }
                getAchPerListDataApi(
                    reqObj,
                    function (res) {
                        // console.log('获取列表数据', res)
                        _this.renderListData = res.data.list // 列表数据赋值
                        _this.listDataCount = res.data.count // 数据总量
                        $('html , body').animate({scrollTop: 0}, 'slow')// 回到顶部
                        if (_this.renderListData.length == 0) {
                            _this.isEmpty = 'flex'
                        }
                        $(".pageSizeSelect").val(_this.pageSize) // 更新每页尺寸
                        _this.$nextTick(function () {
                            // 文本溢出隐藏（兼容处理）
                            _this.textOverflowEllipsis()
                        })
                    },
                    function (res) {
                        _this.isEmpty = 'flex'
                        _this.$message({
                            message: '请求出错, 请稍后再访问',
                            type: 'error',
                            offset: 90
                        })
                    },
                    function () {
                        _this.loading = false // 停止加载 loading
                    }
                )
            },
            getAttentionNum: function () { // 关注数量
                var _this = this
                myFollowCountApi(
                    function (res) {
                        _this.attentionNum = res.data
                    }
                )
            },
            resetAreaNameList: function (_this) { // 重置行业分类
                // 注意： 这里的 _this 仍然指向 vue
                _this.areaNameList = [] //（请求用）行业分类
                _this.allIndClassArr.forEach(function (item) {
                    item.isSel = 0
                })
            },
            resetProvinceList: function (_this) { // 重置省份分类
                // 注意： 这里的 _this 仍然指向 vue
                _this.provinceList = [] //（请求用）行业分类
                _this.chiProvinceArr.forEach(function (item) {
                    item.isSel = 0
                })
            },
            resetGrayFilterItems: function () { // 重置 排序
                this.addDateSort = ''
                this.hotSort = ''
            },
            setAreaNameList: function (id) { // 设置行业分类
                var _this = this
                // 一些重置
                this.isGetAttentionList = false // 重置为列表获取
                _this.page = 1
                // this.resetGrayFilterItems()
                if (id === 0) { // 点击“不限”
                    _this.resetAreaNameList(_this) // 重置筛选项-行业分类
                } else { //  点击子项
                    _this.allIndClassArr.forEach(function (item) {
                        if (item.id === id) {
                            if (item.isSel === 0) {
                                item.isSel = 1
                                _this.areaNameList.push(item.id)
                            } else {
                                item.isSel = 0
                                _this.areaNameList.splice(_this.areaNameList.indexOf(item.id), 1)
                            }
                        }
                    })
                }
                // console.log('当前请求行业', _this.areaNameList)
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            setProvinceList: function (curItem) { // 设置省份
                var _this = this
                _this.page = 1
                // this.resetGrayFilterItems()
                this.isGetAttentionList = false // 重置为列表获取
                if (curItem === 0) { // 点击“不限”
                    _this.resetProvinceList(_this) // 重置筛选项-省份分类
                } else { //  点击子项
                    _this.chiProvinceArr.forEach(function (item) {
                        if (item.Proname === curItem.Proname) {
                            if (item.isSel === 0) {
                                item.isSel = 1
                                _this.provinceList.push(item.Proname)
                            } else {
                                item.isSel = 0
                                _this.provinceList.splice(_this.provinceList.indexOf(item.Proname), 1)
                            }
                        }
                    })
                }
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            setFilterItems: function (type) { // 设置过滤项
                this.page = 1
                if (type === 0) { //综合排序
                    // 处理请求数据
                    this.addDateSort = ''
                    this.hotSort = ''
                } else if (type === 1) { // 入库时间
                    // 处理请求数据
                    this.hotSort = ''
                    if (this.addDateSort == 2) {
                        this.addDateSort = 1
                    } else {
                        this.addDateSort = 2
                    }
                } else { // 热度排序
                    this.addDateSort = ''
                    // 处理请求数据
                    if (this.hotSort == 2) {
                        this.hotSort = 1
                    } else {
                        this.hotSort = 2
                    }
                }
                // this.getListData() // 重新获取数据
                this.isGetAttentionList ? this.getAttentionList() : this.getListData()
            },
            changeAttention: function (isAttention, id) { // 关注操作
                var _this = this
                if (!_this.isLogin()) return // 判断是否有 “登录”字体
                var reqObj = {
                    recordId: id
                }
                if (isAttention === 1) { // 已关注-取消关注
                    deleteFollowApi(
                        reqObj,
                        function (res) {
                            _this.$message({
                                message: '取消关注成功！',
                                type: 'success',
                                offset: 90
                            })
                            _this.renderListData.forEach(function (item) {
                                if (item.recordId === id) {
                                    item.followCount = res.data
                                    item.isFollow = 0
                                }
                            })
                            _this.attentionNum--
                        },
                        function (res) {
                            console.log(res)
                            _this.$message({
                                message: '关注操作失败！请刷新页面重新尝试',
                                type: 'error',
                                offset: 90
                            })
                        }
                    )
                } else { // 未关注-添加关注
                    addFollowApi(
                        reqObj,
                        function (res) {
                            _this.$message({
                                message: '添加关注成功！',
                                type: 'success',
                                offset: 90
                            })
                            _this.renderListData.forEach(function (item) {
                                if (item.recordId === id) {
                                    item.followCount = res.data
                                    item.isFollow = 1
                                }
                            })
                            _this.attentionNum++
                        },
                        function (res) {
                            console.log(res)
                            _this.$message({
                                message: '关注操作失败！请刷新页面重新尝试',
                                type: 'error',
                                offset: 90
                            })
                        }
                    )
                }
            },
            getAttentionData: function() {
                var _this = this
                _this.isGetAttentionList = true
                // 重置
                _this.keyword = '' // 关键词
                _this.resetAreaNameList(_this) // 行业分类
                _this.resetProvinceList(_this) // 省份
                _this.resetGrayFilterItems()// 排序选项
                _this.page = 1
                this.getAttentionList()
            },
            getAttentionList: function () { // 获取已关注科技人才
                var _this = this
                _this.loading = true // 开始加载 loading
                _this.isEmpty = 'none' // 隐藏置空
                _this.renderListData = [] // 清空数据
                var reqObj = {
                    'page.currentPage': _this.page,
                    pageSize: _this.pageSize,
                    // keyword: _this.keyword,
                    // areaNameList: _this.areaNameList.join(','),
                    // provinceList: _this.provinceList.join(','),
                    addDateSort: _this.addDateSort,
                    hotSort: _this.hotSort
                }
                hasAttentionAchList(
                    reqObj,
                    function (res) {
                        _this.renderListData = res.data.list // 列表数据赋值
                        _this.listDataCount = res.data.count // 数据总量
                        $('html , body').animate({scrollTop: 0}, 'slow')// 回到顶部
                        if (_this.renderListData.length == 0) {
                            _this.isEmpty = 'flex'
                        }
                        $(".pageSizeSelect").val(_this.pageSize) // 更新每页尺寸
                        _this.$nextTick(function () {
                            // 文本溢出隐藏（兼容处理）
                            _this.textOverflowEllipsis()
                        })
                    },
                    function (res) {
                        _this.$message({
                            message: '获取失败！请刷新页面重新尝试',
                            type: 'error',
                            offset: 90
                        })
                    },
                    function () {
                        _this.loading = false // 停止加载 loading
                    }
                )
            }
        }, listdetailreuse)
})
